Index: branches/HTM-14.1-update-dev1-HHI/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1209)
@@ -528,5 +528,5 @@
   // initialize global variables
   initROM();  
-#if H_3D_DIM_DMM
+#if NH_3D_DMM
   initWedgeLists();
 #endif
Index: branches/HTM-14.1-update-dev1-HHI/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1209)
@@ -1773,5 +1773,5 @@
   // allocate slice-based dQP values
 #if NH_MV
-  for (Int i = m_layerIdInNuh.size(); i < m_numberOfLayers; i++ )
+  for (Int i = (Int)m_layerIdInNuh.size(); i < m_numberOfLayers; i++ )
   {
     m_layerIdInNuh.push_back( i == 0 ? 0 : m_layerIdInNuh[ i - 1 ] + 1 ); 
Index: branches/HTM-14.1-update-dev1-HHI/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1209)
@@ -811,5 +811,5 @@
   // initialize global variables
   initROM();
-#if H_3D_DIM_DMM
+#if NH_3D_DMM
   initWedgeLists( true );
 #endif
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/ContextTables.h
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/ContextTables.h	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/ContextTables.h	(revision 1209)
@@ -173,18 +173,16 @@
 #define CNU                          154      ///< dummy initialization value for unused context models 'Context model Not Used'
 
-#if H_3D_DIM
-#define NUM_DEPTH_INTRA_MODE_CTX      1       ///< number of context models for depth intra modes
-#define NUM_DDC_FLAG_CTX              2       ///< number of context models for deltaDC flag (DMM or RBC)
-#define NUM_DDC_DATA_CTX              1       ///< number of context models for deltaDC data (DMM or RBC)
-#if H_3D_DIM_DMM
-#define NUM_DMM1_DATA_CTX             1       ///< number of context models for DMM1 data
-#endif
-#define NUM_ANGLE_FLAG_CTX            1
-#endif
-
+#if NH_3D_DMM
+#define NUM_NOTDMM_FLAG_CTX           1       ///< number of context models for not-DMM flag
+#define NUM_DMM_MODE_CTX              1       ///< number of context models for DMM modes
+#endif
+#if NH_3D_DMM || NH_3D_SDC
+#define NUM_DDC_DATA_CTX              1       ///< number of context models for deltaDC data (DMM or SDC)
+#endif
 #if H_3D_DIM_SDC
 #define SDC_NUM_RESIDUAL_FLAG_CTX     1
 #define SDC_NUM_RESIDUAL_CTX          1
 #define NUM_SDC_FLAG_CTX              1      ///< number of context 
+#define NUM_DDC_FLAG_CTX              2       ///< number of context models for deltaDC flag (SDC only)
 #endif
 #if H_3D_DBBP
@@ -562,15 +560,8 @@
 
 #endif
-#if H_3D_DIM
-static const UChar
-INIT_DEPTH_INTRA_MODE[3][NUM_DEPTH_INTRA_MODE_CTX] =
-{
-  { 154, },
-  { 154, },
-  { 154, }
-};
-
+
+#if NH_3D_DMM
 static const UChar 
-INIT_ANGLE_FLAG[3][NUM_ANGLE_FLAG_CTX] =
+INIT_NOTDMM_FLAG[3][NUM_NOTDMM_FLAG_CTX] =
 {
   { 154 },
@@ -578,5 +569,43 @@
   { 155 },
 };
-
+static const UChar 
+INIT_DMM_MODE[3][NUM_DMM_MODE_CTX] =
+{
+  { CNU },
+  { CNU },
+  { CNU }
+};
+#endif
+#if NH_3D_DMM || NH_3D_SDC
+static const UChar
+INIT_DDC_DATA[3][NUM_DDC_DATA_CTX] = 
+{
+  { CNU }, 
+  { CNU }, 
+  { CNU }, 
+};
+#endif
+#if H_3D_DIM_SDC
+static const UChar
+INIT_SDC_RESIDUAL_FLAG[3][SDC_NUM_RESIDUAL_FLAG_CTX] =
+{
+  { CNU },
+  { CNU },
+  { CNU },
+};
+static const UChar
+INIT_SDC_RESIDUAL[3][SDC_NUM_RESIDUAL_CTX] =
+{
+  { 155 },
+  { 155 },
+  { 155 },
+};
+static const UChar 
+INIT_SDC_FLAG[3][NUM_SDC_FLAG_CTX] =
+{
+  { 154 },  
+  { 154 },
+  { 154 },
+};
 static const UChar 
 INIT_DDC_FLAG[3][NUM_DDC_FLAG_CTX] =
@@ -586,47 +615,5 @@
   {64, CNU}
 };
-static const UChar
-INIT_DDC_DATA[3][NUM_DDC_DATA_CTX] = 
-{
-  { 154 }, 
-  { 154 }, 
-  { 154 }, 
-};
-#if H_3D_DIM_DMM
-static const UChar
-INIT_DMM1_DATA[3][NUM_DMM1_DATA_CTX] = 
-{
-  { CNU }, 
-  { CNU }, 
-  { CNU }, 
-};
-#endif
-#if H_3D_DIM_SDC
-static const UChar
-INIT_SDC_RESIDUAL_FLAG[3][SDC_NUM_RESIDUAL_FLAG_CTX] =
-{
-  { CNU },
-  { CNU },
-  { CNU },
-};
-static const UChar
-INIT_SDC_RESIDUAL[3][SDC_NUM_RESIDUAL_CTX] =
-{
-  { 155 },
-  { 155 },
-  { 155 },
-};
-#endif
-#endif
-#if H_3D_DIM_SDC
-static const UChar 
-INIT_SDC_FLAG[3][NUM_SDC_FLAG_CTX] =
-{
-  { 154 },  
-  { 154 },
-  { 154 },
-};
-#endif
-
+#endif
 #if H_3D_DBBP
 static const UChar INIT_DBBP_FLAG[3][DBBP_NUM_FLAG_CTX] =
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComCodingStatistics.h
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComCodingStatistics.h	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComCodingStatistics.h	(revision 1209)
@@ -92,4 +92,16 @@
   STATS__CABAC_BITS__ALIGNED_SIGN_BIT,
   STATS__CABAC_BITS__ALIGNED_ESCAPE_BITS,
+
+#if NH_3D_DMM || H_3D_DIM_SDC || H_3D_INTER_SDC
+  STATS__CABAC_BITS__DELTADC_SIGN_EP,
+  STATS__CABAC_BITS__DELTADC_PREFIX,
+  STATS__CABAC_BITS__DELTADC_SUFFIX_EP,
+#endif
+#if NH_3D_DMM
+  STATS__CABAC_BITS__NOTDMM_FLAG,
+  STATS__CABAC_BITS__DMMMODE,
+  STATS__CABAC_BITS__DMM1_BITS_EP,
+#endif
+
   STATS__NUM_STATS
 };
@@ -142,4 +154,14 @@
     "CABAC_BITS__ALIGNED_SIGN_BIT",
     "CABAC_BITS__ALIGNED_ESCAPE_BITS"
+#if NH_3D_DMM || H_3D_DIM_SDC || H_3D_INTER_SDC
+   ,"STATS__CABAC_BITS__DELTADC_SIGN_EP"
+   ,"STATS__CABAC_BITS__DELTADC_PREFIX"
+   ,"STATS__CABAC_BITS__DELTADC_SUFFIX_EP"
+#endif
+#if NH_3D_DMM
+   ,"STATS__CABAC_BITS__NOTDMM_FLAG"
+   ,"STATS__CABAC_BITS__DMMMODE"
+   ,"STATS__CABAC_BITS__DMM1_BITS_EP"
+#endif
   };
   assert(STATS__NUM_STATS == sizeof(statNames)/sizeof(Char *) && name < STATS__NUM_STATS);
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1209)
@@ -104,15 +104,11 @@
   }
 
-#if H_3D_DIM
-  for( Int i = 0; i < DIM_NUM_TYPE; i++ )
-  {
-    m_dimDeltaDC[i][0] = NULL; 
-    m_dimDeltaDC[i][1] = NULL;
-  }
-#if H_3D_DIM_DMM
-  for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-  {
-    m_dmmWedgeTabIdx[i] = NULL;
-  }
+#if NH_3D_DMM
+  for( Int i = 0; i < NUM_DMM; i++ )
+  {
+    m_dmmDeltaDC[i][0] = NULL; 
+    m_dmmDeltaDC[i][1] = NULL;
+  }
+  m_dmm1WedgeTabIdx = NULL;
 #endif
 #if H_3D_DIM_SDC
@@ -120,5 +116,4 @@
   m_apSegmentDCOffset[0]  = NULL;
   m_apSegmentDCOffset[1]  = NULL;
-#endif
 #endif
 
@@ -255,15 +250,11 @@
     m_pbICFlag           = (Bool* )xMalloc(Bool,   uiNumPartition);
 #endif
-#if H_3D_DIM
-    for( Int i = 0; i < DIM_NUM_TYPE; i++ )
-    {
-      m_dimDeltaDC[i][0] = (Pel* )xMalloc(Pel, uiNumPartition); 
-      m_dimDeltaDC[i][1] = (Pel* )xMalloc(Pel, uiNumPartition);
-    }
-#if H_3D_DIM_DMM
-    for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-    {
-      m_dmmWedgeTabIdx[i]    = (UInt*)xMalloc(UInt, uiNumPartition);
-    }
+#if NH_3D_DMM
+    for( Int i = 0; i < NUM_DMM; i++ )
+    {
+      m_dmmDeltaDC[i][0] = (Pel* )xMalloc(Pel, uiNumPartition); 
+      m_dmmDeltaDC[i][1] = (Pel* )xMalloc(Pel, uiNumPartition);
+    }
+    m_dmm1WedgeTabIdx    = (UInt*)xMalloc(UInt, uiNumPartition);
 #endif
 #if H_3D_DIM_SDC
@@ -271,5 +262,4 @@
     m_apSegmentDCOffset[0]  = (Pel*)xMalloc(Pel, uiNumPartition);
     m_apSegmentDCOffset[1]  = (Pel*)xMalloc(Pel, uiNumPartition);
-#endif
 #endif
 #if H_3D_DBBP
@@ -475,15 +465,11 @@
 #endif
 
-#if H_3D_DIM
-    for( Int i = 0; i < DIM_NUM_TYPE; i++ )
-    {
-      if ( m_dimDeltaDC[i][0] ) { xFree( m_dimDeltaDC[i][0] ); m_dimDeltaDC[i][0] = NULL; }
-      if ( m_dimDeltaDC[i][1] ) { xFree( m_dimDeltaDC[i][1] ); m_dimDeltaDC[i][1] = NULL; }
-    }
-#if H_3D_DIM_DMM
-    for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-    {
-      if ( m_dmmWedgeTabIdx[i] ) { xFree( m_dmmWedgeTabIdx[i] ); m_dmmWedgeTabIdx[i] = NULL; }
-    }
+#if NH_3D_DMM
+    for( Int i = 0; i < NUM_DMM; i++ )
+    {
+      if ( m_dmmDeltaDC[i][0] ) { xFree( m_dmmDeltaDC[i][0] ); m_dmmDeltaDC[i][0] = NULL; }
+      if ( m_dmmDeltaDC[i][1] ) { xFree( m_dmmDeltaDC[i][1] ); m_dmmDeltaDC[i][1] = NULL; }
+    }
+    if ( m_dmm1WedgeTabIdx    ) { xFree( m_dmm1WedgeTabIdx );  m_dmm1WedgeTabIdx = NULL;  }
 #endif
 #if H_3D_DIM_SDC
@@ -491,5 +477,4 @@
     if ( m_apSegmentDCOffset[0] ) { xFree(m_apSegmentDCOffset[0]);  m_apSegmentDCOffset[0]  = NULL; }
     if ( m_apSegmentDCOffset[1] ) { xFree(m_apSegmentDCOffset[1]);  m_apSegmentDCOffset[1]  = NULL; }
-#endif    
 #endif    
 #if H_3D_DBBP
@@ -659,15 +644,12 @@
 
 
-#if H_3D_DIM
-    for( Int i = 0; i < DIM_NUM_TYPE; i++ )
-    {
-      memset( m_dimDeltaDC[i][0] + firstElement, 0,                       numElements * sizeof( *m_dimDeltaDC[i][0] ) );
-      memset( m_dimDeltaDC[i][1] + firstElement, 0,                       numElements * sizeof( *m_dimDeltaDC[i][1] ) );
-    }
-#if H_3D_DIM_DMM
-    for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-    {
-      memset( m_dmmWedgeTabIdx[i] + firstElement, 0,                      numElements * sizeof( *m_dmmWedgeTabIdx[i] ) );
-    }
+
+#if NH_3D_DMM
+  for( Int i = 0; i < NUM_DMM; i++ )
+  {
+    memset( m_dmmDeltaDC[i][0], 0,                        m_uiNumPartition * sizeof( *m_dmmDeltaDC[i][0] ) );
+    memset( m_dmmDeltaDC[i][1], 0,                        m_uiNumPartition * sizeof( *m_dmmDeltaDC[i][1] ) );
+  }
+  memset( m_dmm1WedgeTabIdx,    0,                        m_uiNumPartition * sizeof( *m_dmm1WedgeTabIdx   ) );
 #endif
 #if H_3D_DIM_SDC
@@ -675,7 +657,8 @@
     memset( m_apSegmentDCOffset[0]  + firstElement,     0,                numElements * sizeof( *m_apSegmentDCOffset[0] ) );
     memset( m_apSegmentDCOffset[1]  + firstElement,     0,                numElements * sizeof( *m_apSegmentDCOffset[1] ) );
-#endif
+#if !TEMP_SDC_CLEANUP // PM: should be obsolete after cleanup
     m_apDmmPredictor[0] = 0;
     m_apDmmPredictor[1] = 0;
+#endif
 #endif
 #if H_3D_DBBP
@@ -820,15 +803,11 @@
 
 
-#if H_3D_DIM
-      for( Int i = 0; i < DIM_NUM_TYPE; i++ )
-      {
-        m_dimDeltaDC[i][0] [ui] = 0;
-        m_dimDeltaDC[i][1] [ui] = 0;
-      }
-#if H_3D_DIM_DMM
-      for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-      {
-        m_dmmWedgeTabIdx[i] [ui] = 0;
-      }
+#if NH_3D_DMM
+    for( Int i = 0; i < NUM_DMM; i++ )
+    {
+      m_dmmDeltaDC[i][0] [ui] = 0;
+      m_dmmDeltaDC[i][1] [ui] = 0;
+    }
+    m_dmm1WedgeTabIdx    [ui] = 0;
 #endif
 #if H_3D_DIM_SDC
@@ -836,7 +815,8 @@
       m_apSegmentDCOffset[0][ui] = 0;
       m_apSegmentDCOffset[1][ui] = 0;
-#endif
+#if !TEMP_SDC_CLEANUP // PM: should be obsolete after cleanup
       m_apDmmPredictor[0] = 0;
       m_apDmmPredictor[1] = 0;
+#endif
 #endif
 #if H_3D_DBBP
@@ -929,15 +909,11 @@
   memset( m_pbICFlag,          0, iSizeInBool  );
 #endif
-#if H_3D_DIM
-  for( Int i = 0; i < DIM_NUM_TYPE; i++ )
-  {
-    memset( m_dimDeltaDC[i][0], 0, sizeof(Pel ) * m_uiNumPartition );
-    memset( m_dimDeltaDC[i][1], 0, sizeof(Pel ) * m_uiNumPartition );
-  }
-#if H_3D_DIM_DMM
-  for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-  {
-    memset( m_dmmWedgeTabIdx[i], 0, sizeof(UInt) * m_uiNumPartition );
-  }
+#if NH_3D_DMM
+  for( Int i = 0; i < NUM_DMM; i++ )
+  {
+    memset( m_dmmDeltaDC[i][0], 0, sizeof(Pel ) * m_uiNumPartition );
+    memset( m_dmmDeltaDC[i][1], 0, sizeof(Pel ) * m_uiNumPartition );
+  }
+  memset( m_dmm1WedgeTabIdx,    0, sizeof(UInt) * m_uiNumPartition );
 #endif
 #if H_3D_DIM_SDC
@@ -945,7 +921,8 @@
   memset( m_apSegmentDCOffset[0], 0, sizeof(Pel) * m_uiNumPartition   );
   memset( m_apSegmentDCOffset[1], 0, sizeof(Pel) * m_uiNumPartition   );
-#endif
+#if !TEMP_SDC_CLEANUP // PM: should be obsolete after cleanup
   m_apDmmPredictor[0] = 0;
   m_apDmmPredictor[1] = 0;
+#endif
 #endif
 #if H_3D_DBBP
@@ -989,15 +966,11 @@
       m_pbICFlag          [ui] = pcCU->m_pbICFlag[uiPartOffset+ui];
 #endif
-#if H_3D_DIM
-      for( Int i = 0; i < DIM_NUM_TYPE; i++ )
-      {
-        m_dimDeltaDC[i][0] [ui] = pcCU->m_dimDeltaDC[i][0] [uiPartOffset+ui];
-        m_dimDeltaDC[i][1] [ui] = pcCU->m_dimDeltaDC[i][1] [uiPartOffset+ui];
-      }
-#if H_3D_DIM_DMM
-      for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-      {
-        m_dmmWedgeTabIdx[i] [ui] = pcCU->m_dmmWedgeTabIdx[i] [uiPartOffset+ui];
-      }
+#if NH_3D_DMM
+  for( Int i = 0; i < NUM_DMM; i++ )
+  {
+    m_dmmDeltaDC[i][0] [ui] = pcCU->m_dmmDeltaDC[i][0] [uiPartOffset+ui];
+    m_dmmDeltaDC[i][1] [ui] = pcCU->m_dmmDeltaDC[i][1] [uiPartOffset+ui];
+  }
+  m_dmm1WedgeTabIdx    [ui] = pcCU->m_dmm1WedgeTabIdx  [uiPartOffset+ui];
 #endif
 #if H_3D_DIM_SDC
@@ -1005,5 +978,4 @@
       m_apSegmentDCOffset[0][ui] = pcCU->m_apSegmentDCOffset[0] [ uiPartOffset + ui ];
       m_apSegmentDCOffset[1][ui] = pcCU->m_apSegmentDCOffset[1] [ uiPartOffset + ui ];
-#endif
 #endif
 #if H_3D_DBBP
@@ -1112,15 +1084,11 @@
     m_explicitRdpcmMode[comp]             = pcCU->getExplicitRdpcmMode(ComponentID(comp))             + uiPart;
   }
-#if H_3D_DIM
-  for( Int i = 0; i < DIM_NUM_TYPE; i++ )
-  {
-    m_dimDeltaDC[i][0] = pcCU->getDimDeltaDC( i, 0 ) + uiPart;
-    m_dimDeltaDC[i][1] = pcCU->getDimDeltaDC( i, 1 ) + uiPart;
-  }
-#if H_3D_DIM_DMM
-  for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-  {
-    m_dmmWedgeTabIdx[i] = pcCU->getDmmWedgeTabIdx( i ) + uiPart;
-  }
+#if NH_3D_DMM
+  for( Int i = 0; i < NUM_DMM; i++ )
+  {
+    m_dmmDeltaDC[i][0] = pcCU->getDmmDeltaDC( (DmmID)i, 0 ) + uiPart;
+    m_dmmDeltaDC[i][1] = pcCU->getDmmDeltaDC( (DmmID)i, 1 ) + uiPart;
+  }
+  m_dmm1WedgeTabIdx    = pcCU->getDmm1WedgeTabIdx()  + uiPart;
 #endif
 #if H_3D_DIM_SDC
@@ -1128,5 +1096,4 @@
   m_apSegmentDCOffset[0]    = pcCU->getSDCSegmentDCOffset(0)  + uiPart;
   m_apSegmentDCOffset[1]    = pcCU->getSDCSegmentDCOffset(1)  + uiPart;
-#endif  
 #endif  
 #if H_3D_DBBP
@@ -1319,15 +1286,11 @@
     memcpy( m_explicitRdpcmMode[comp]             + uiOffset, pcCU->getExplicitRdpcmMode(ComponentID(comp))            , iSizeInUchar );
   }
-#if H_3D_DIM
-  for( Int i = 0; i < DIM_NUM_TYPE; i++ )
-  {
-    memcpy( m_dimDeltaDC[i][0] + uiOffset, pcCU->getDimDeltaDC( i, 0 ), sizeof(Pel ) * uiNumPartition );
-    memcpy( m_dimDeltaDC[i][1] + uiOffset, pcCU->getDimDeltaDC( i, 1 ), sizeof(Pel ) * uiNumPartition );
-  }
-#if H_3D_DIM_DMM
-  for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-  {
-    memcpy( m_dmmWedgeTabIdx[i] + uiOffset, pcCU->getDmmWedgeTabIdx( i ), sizeof(UInt) * uiNumPartition );
-  }
+#if NH_3D_DMM
+  for( Int i = 0; i < NUM_DMM; i++ )
+  {
+    memcpy( m_dmmDeltaDC[i][0] + uiOffset, pcCU->getDmmDeltaDC( (DmmID)i, 0 ), sizeof(Pel ) * uiNumPartition );
+    memcpy( m_dmmDeltaDC[i][1] + uiOffset, pcCU->getDmmDeltaDC( (DmmID)i, 1 ), sizeof(Pel ) * uiNumPartition );
+  }
+  memcpy( m_dmm1WedgeTabIdx    + uiOffset, pcCU->getDmm1WedgeTabIdx(),         sizeof(UInt) * uiNumPartition );
 #endif
 #if H_3D_DIM_SDC
@@ -1335,5 +1298,4 @@
   memcpy( m_apSegmentDCOffset[0]  + uiOffset, pcCU->getSDCSegmentDCOffset(0), sizeof( Pel ) * uiNumPartition);
   memcpy( m_apSegmentDCOffset[1]  + uiOffset, pcCU->getSDCSegmentDCOffset(1), sizeof( Pel ) * uiNumPartition);
-#endif
 #endif
 #if H_3D_DBBP
@@ -1447,15 +1409,11 @@
   }
 
-#if H_3D_DIM
-  for( Int i = 0; i < DIM_NUM_TYPE; i++ )
-  {
-    memcpy( rpcCU->getDimDeltaDC( i, 0 ) + m_uiAbsIdxInLCU, m_dimDeltaDC[i][0], sizeof(Pel ) * m_uiNumPartition );
-    memcpy( rpcCU->getDimDeltaDC( i, 1 ) + m_uiAbsIdxInLCU, m_dimDeltaDC[i][1], sizeof(Pel ) * m_uiNumPartition );
-  }
-#if H_3D_DIM_DMM
-  for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-  {
-    memcpy( rpcCU->getDmmWedgeTabIdx( i ) + m_uiAbsIdxInLCU, m_dmmWedgeTabIdx[i], sizeof(UInt) * m_uiNumPartition );
-  }
+#if NH_3D_DMM
+  for( Int i = 0; i < NUM_DMM; i++ )
+  {
+    memcpy( pCtu->getDmmDeltaDC( (DmmID)i, 0 ) + m_absZIdxInCtu, m_dmmDeltaDC[i][0], sizeof(Pel ) * m_uiNumPartition );
+    memcpy( pCtu->getDmmDeltaDC( (DmmID)i, 1 ) + m_absZIdxInCtu, m_dmmDeltaDC[i][1], sizeof(Pel ) * m_uiNumPartition );
+  }
+  memcpy( pCtu->getDmm1WedgeTabIdx()           + m_absZIdxInCtu, m_dmm1WedgeTabIdx,  sizeof(UInt) * m_uiNumPartition );
 #endif
 #if H_3D_DIM_SDC
@@ -1463,5 +1421,4 @@
   memcpy( rpcCU->getSDCSegmentDCOffset(0) + m_uiAbsIdxInLCU, m_apSegmentDCOffset[0], sizeof( Pel ) * m_uiNumPartition);
   memcpy( rpcCU->getSDCSegmentDCOffset(1) + m_uiAbsIdxInLCU, m_apSegmentDCOffset[1], sizeof( Pel ) * m_uiNumPartition);
-#endif
 #endif
 #if H_3D_DBBP
@@ -1522,21 +1479,8 @@
   memcpy( rpcCU->getSPIVMPFlag()        + uiPartOffset, m_pbSPIVMPFlag,        sizeof(Bool) * uiQNumPart );
 #endif
-#if H_3D_DIM
-  for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-  {
-    memcpy( rpcCU->getDimDeltaDC( i, 0 ) + uiPartOffset, m_dimDeltaDC[i][0], sizeof(Pel ) * uiQNumPart );
-    memcpy( rpcCU->getDimDeltaDC( i, 1 ) + uiPartOffset, m_dimDeltaDC[i][1], sizeof(Pel ) * uiQNumPart );
-  }
-#if H_3D_DIM_DMM
-  for( Int i = 0; i < DMM_NUM_TYPE; i++ )
-  {
-    memcpy( rpcCU->getDmmWedgeTabIdx( i ) + uiPartOffset, m_dmmWedgeTabIdx[i], sizeof(UInt) * uiQNumPart );
-  }
-#endif
 #if H_3D_DIM_SDC
   memcpy( rpcCU->getSDCFlag()             + uiPartOffset, m_pbSDCFlag,      iSizeInBool  );
   memcpy( rpcCU->getSDCSegmentDCOffset(0) + uiPartOffset, m_apSegmentDCOffset[0], sizeof( Pel ) * uiQNumPart);
   memcpy( rpcCU->getSDCSegmentDCOffset(1) + uiPartOffset, m_apSegmentDCOffset[1], sizeof( Pel ) * uiQNumPart);
-#endif
 #endif
 #if H_3D_DBBP
@@ -1952,6 +1896,6 @@
   }
   iLeftIntraDir  = pcCULeft ? ( pcCULeft->isIntra( LeftPartIdx ) ? pcCULeft->getIntraDir( chType, LeftPartIdx ) : DC_IDX ) : DC_IDX;
-#if H_3D_DIM
-  mapDepthModeToIntraDir( iLeftIntraDir );
+#if NH_3D_DMM
+  mapDmmToIntraDir( iLeftIntraDir );
 #endif
 
@@ -1964,6 +1908,6 @@
   }
   iAboveIntraDir = pcCUAbove ? ( pcCUAbove->isIntra( AbovePartIdx ) ? pcCUAbove->getIntraDir( chType, AbovePartIdx ) : DC_IDX ) : DC_IDX;
-#if H_3D_DIM
-  mapDepthModeToIntraDir( iAboveIntraDir );
+#if NH_3D_DMM
+  mapDmmToIntraDir( iAboveIntraDir );
 #endif
 
@@ -2460,4 +2404,15 @@
 Bool TComDataCU::getSDCAvailable( UInt uiAbsPartIdx )
 {
+#if TEMP_SDC_CLEANUP // PM: consider this cleanup for DMM and SDC
+  if( getSlice()->getIsDepth() && isIntra(uiAbsPartIdx) && getPartitionSize(uiAbsPartIdx) == SIZE_2Nx2N )
+  {
+    UInt lumaPredMode = getIntraDir( CHANNEL_TYPE_LUMA, uiAbsPartIdx );
+    if( lumaPredMode < NUM_INTRA_MODE ) { return true; }
+#if NH_3D_DMM
+    if( isDmmMode( lumaPredMode )     ) { return true; }
+#endif
+  }
+  return false;
+#else
   // check general CU information
   if( !getSlice()->getIsDepth() || !isIntra(uiAbsPartIdx) || getPartitionSize(uiAbsPartIdx) != SIZE_2Nx2N )
@@ -2466,5 +2421,5 @@
   }
 
-  if( isDimMode( getLumaIntraDir( uiAbsPartIdx ) ) )
+  if( isDmmMode( getLumaIntraDir( uiAbsPartIdx ) ) )
   {
     return true;
@@ -2479,9 +2434,10 @@
   // check prediction mode
   UInt uiLumaPredMode = getLumaIntraDir( uiAbsPartIdx );  
-  if( uiLumaPredMode == PLANAR_IDX || ( getDimType( uiLumaPredMode ) == DMM1_IDX  ) )
+  if( uiLumaPredMode == PLANAR_IDX || ( getDmmType( uiLumaPredMode ) == DMM1_IDX  ) )
     return true;
   
   // else
   return false;
+#endif
 }
 #endif
@@ -5637,7 +5593,6 @@
 
   UInt uiDirMode  = getIntraDir(toChannelType(compID), uiAbsPartIdx);
-
-#if H_3D_DIM
-    mapDepthModeToIntraDir( uiDirMode );
+#if NH_3D_DMM
+  mapDmmToIntraDir( uiDirMode );
 #endif
 
@@ -5647,6 +5602,6 @@
     const UInt partsPerMinCU = 1<<(2*(sps->getMaxTotalCUDepth() - sps->getLog2DiffMaxMinCodingBlockSize()));
     uiDirMode = getIntraDir(CHANNEL_TYPE_LUMA, getChromasCorrespondingPULumaIdx(uiAbsPartIdx, getPic()->getChromaFormat(), partsPerMinCU));
-#if H_3D_DIM
-      mapDepthModeToIntraDir( uiDirMode );
+#if NH_3D_DMM
+    mapDmmToIntraDir( uiDirMode );
 #endif
   }
@@ -6732,12 +6687,9 @@
 }
 #endif
-#if H_3D_DIM_DMM
-Void TComDataCU::setDmmWedgeTabIdxSubParts( UInt tabIdx, UInt dmmType, UInt uiAbsPartIdx, UInt uiDepth )
-{
-  UInt uiCurrPartNumb = m_pcPic->getNumPartInCU() >> (uiDepth << 1);
-  for( UInt ui = 0; ui < uiCurrPartNumb; ui++ )
-  { 
-    m_dmmWedgeTabIdx[dmmType][uiAbsPartIdx+ui] = tabIdx; 
-  }
+#if NH_3D_DMM
+Void TComDataCU::setDmm1WedgeTabIdxSubParts( UInt tabIdx, UInt uiAbsPartIdx, UInt uiDepth )
+{
+  UInt uiCurrPartNumb = m_pcPic->getNumPartitionsInCtu() >> (uiDepth << 1);
+  for( UInt ui = 0; ui < uiCurrPartNumb; ui++ ) { m_dmm1WedgeTabIdx[uiAbsPartIdx+ui] = tabIdx; }
 }
 #endif
Index: branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComDataCU.h	(revision 1203)
+++ branches/HTM-14.1-update-dev1-HHI/source/Lib/TLibCommon/TComDataCU.h	(revision 1209)
@@ -182,12 +182,12 @@
   Bool*         m_pbICFlag;           ///< array of IC flags
 #endif
-#if H_3D_DIM
-  Pel*          m_dimDeltaDC[DIM_NUM_TYPE][2];
-#if H_3D_DIM_DMM
-  UInt*         m_dmmWedgeTabIdx[DMM_NUM_TYPE]; 
+#if NH_3D_DMM
+  Pel*          m_dmmDeltaDC[NUM_DMM][2];
+  UInt*         m_dmm1WedgeTabIdx;
 #endif
 #if H_3D_DIM_SDC
   Bool*         m_pbSDCFlag;
   Pel*          m_apSegmentDCOffset[2];
+#if !TEMP_SDC_CLEANUP // PM: should be obsolete after cleanup
   Pel           m_apDmmPredictor[2];
 #endif
@@ -553,14 +553,13 @@
   Bool          isFirstAbsZorderIdxInDepth (UInt uiAbsPartIdx, UInt uiDepth);
 
-#if H_3D_DIM
-  Pel*  getDimDeltaDC                 ( UInt dimType, UInt segId )                      { return m_dimDeltaDC[dimType][segId];        } 
-  Pel   getDimDeltaDC                 ( UInt dimType, UInt segId, UInt uiIdx )          { return m_dimDeltaDC[dimType][segId][uiIdx]; } 
-  Void  setDimDeltaDC                 ( UInt dimType, UInt segId, UInt uiIdx, Pel val ) { m_dimDeltaDC[dimType][segId][uiIdx] = val;  }
-#if H_3D_DIM_DMM
-  UInt* getDmmWedgeTabIdx             ( UInt dmmType )                          { return m_dmmWedgeTabIdx[dmmType];          }        
-  UInt  getDmmWedgeTabIdx             ( UInt dmmType, UInt uiIdx )              { return m_dmmWedgeTabIdx[dmmType][uiIdx];   }
-  Void  setDmmWedgeTabIdx             ( UInt dmmType, UInt uiIdx, UInt tabIdx ) { m_dmmWedgeTabIdx[dmmType][uiIdx] = tabIdx; }
-  Void  setDmmWedgeTabIdxSubParts     ( UInt tabIdx, UInt dmmType, UInt uiAbsPartIdx, UInt uiDepth );
-
+#if NH_3D_DMM
+  Pel*  getDmmDeltaDC                 ( DmmID dmmType, UInt segId )                      { return m_dmmDeltaDC[dmmType][segId];        } 
+  Pel   getDmmDeltaDC                 ( DmmID dmmType, UInt segId, UInt uiIdx )          { return m_dmmDeltaDC[dmmType][segId][uiIdx]; } 
+  Void  setDmmDeltaDC                 ( DmmID dmmType, UInt segId, UInt uiIdx, Pel val ) { m_dmmDeltaDC[dmmType][segId][uiIdx] = val;  }
+
+  UInt* getDmm1WedgeTabIdx            ()                                                { return m_dmm1WedgeTabIdx;          }        
+  UInt  getDmm1WedgeTabIdx            ( UInt uiIdx )                                    { return m_dmm1WedgeTabIdx[uiIdx];   }
+  Void  setDmm1WedgeTabIdx            ( UInt uiIdx, UInt tabIdx )                       { m_dmm1WedgeTabIdx[uiIdx] = tabIdx; }
+  Void  setDmm1WedgeTabIdxSubParts    ( UInt tabIdx, UInt uiAbsPartIdx, UInt uiDepth );
 #endif
 #if H_3D_DIM_SDC
@@ -574,8 +573,9 @@
   Pel           getSDCSegmentDCOffset( UInt uiSeg, UInt uiPartIdx ) { return m_apSegmentDCOffset[uiSeg][uiPartIdx]; }
   Void          setSDCSegmentDCOffset( Pel pOffset, UInt uiSeg, UInt uiPartIdx) { m_apSegmentDCOffset[uiSeg][uiPartIdx] = pOffset; }
+#if !TEMP_SDC_CLEANUP // PM: should be obsolete after cleanup
   Void          setDmmPredictor ( Pel pOffset, UInt uiSeg) { m_apDmmPredictor[uiSeg] = pOffset; }
   Pel           getDmmPredictor ( UInt uiSeg) { return m_apDmmPredictor[uiSeg]; }
+#endif
   UInt          getCtxSDCFlag          ( UInt   uiAbsPartIdx );
-#endif
 #endif
   
@@ -747,9 +747,10 @@
   UInt          getCoefScanIdx(const UInt uiAbsPartIdx, const UInt uiWidth, const UInt uiHeight, const ComponentID compID) const ;
 
-#if H_3D_DIM
+#if !TEMP_SDC_CLEANUP // PM: should be obsolete after cleanup
+#if NH_3D_DMM
   Bool         isDMM1UpscaleMode       ( UInt uiWidth ){ Bool bDMM1UpsampleModeFlag = true; UInt uiBaseWidth = 16; if( uiBaseWidth >= uiWidth ){ bDMM1UpsampleModeFlag = false; } return bDMM1UpsampleModeFlag; };
   UInt         getDMM1BasePatternWidth ( UInt uiWidth ){ UInt uiBaseWidth = 16; if( uiBaseWidth >= uiWidth ){ uiBaseWidth =  uiWidth; } return uiBaseWidth; }
 #endif
-
+#endif
 };
 
